package com.steerinfo.meterwork.meterworkmeterscene.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkmeterscene.model.MeterWorkMeterScene;
import com.steerinfo.meterwork.meterworkmeterscene.service.IMeterWorkMeterSceneService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkMeterScene RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-19 04:32
 * 类描述
 * 修订历史：
 * 日期：2020-10-19
 * 作者：generator
 * 参考：
 * 描述：MeterWorkMeterScene RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkmeterscenes")
@Api(value = "/${api.version}/meterworkmeterscenes", tags = "计量场景配置 - MeterWorkMeterSceneController")
public class MeterWorkMeterSceneController extends BaseRESTfulController {

    @Autowired
    IMeterWorkMeterSceneService meterWorkMeterSceneService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterscene:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        try{ PageList<MeterWorkMeterScene> list = meterWorkMeterSceneService.queryForPage(parmas, pageNum, pageSize);
        return success(list);} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
    }
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterscene:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        try{  PageList<MeterWorkMeterScene> list = meterWorkMeterSceneService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="创建", notes="根据MeterWorkMeterScene对象创建")
    @ApiImplicitParam(name = "meterWorkMeterScene", value = "详细实体meterWorkMeterScene", required = true, dataType = "MeterWorkMeterScene")
    //@RequiresPermissions("meterworkmeterscene:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkMeterScene model){
        try{   MeterWorkMeterScene meterWorkMeterScene = meterWorkMeterSceneService.add(model);
        return success(meterWorkMeterScene);} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterscene:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        try{   MeterWorkMeterScene meterWorkMeterScene = meterWorkMeterSceneService.getById(id);
        return success(meterWorkMeterScene);} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkMeterScene信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkMeterScene", value = "详细实体meterWorkMeterScene", required = true, dataType = "MeterWorkMeterScene")
    })
    //@RequiresPermissions("meterworkmeterscene:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkMeterScene model){
        try{  model.setId(id);
        MeterWorkMeterScene meterWorkMeterScene = meterWorkMeterSceneService.modify(model);
        return success(meterWorkMeterScene);} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterscene:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
        try{	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkMeterSceneService.delete(ids);
    	}
      return success();} catch (Exception ex) {
       ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="创建", notes="根据MeterWorkMeterScene对象创建")
    @ApiImplicitParam(name = "meterWorkMeterScene", value = "详细实体meterWorkMeterScene", required = true, dataType = "MeterWorkMeterScene")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/add")
    public RESTfulResult checkandadd(@RequestBody MeterWorkMeterScene model){
        RESTfulResult rm = failed();
        try{
            MeterWorkMeterScene mwms = meterWorkMeterSceneService.checkandadd(model);
            if (mwms != null) {
                return success(mwms);
            } else {
                return failed("操作失败");
            }
        }catch (MarkerMetException e){
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        }
        catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }finally {

        }
        return rm;
    }

    @ApiOperation(value="删除", notes="根据MeterWorkMeterScene对象删除")
    @PostMapping(value = "/delete")
    public RESTfulResult deleteRe(@RequestBody List<MeterWorkMeterScene> models){
        RESTfulResult rm = failed();
        try{
            int num = meterWorkMeterSceneService.deleteRe(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        }catch (MarkerMetException e){
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        }
        catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }finally {

        }
        return rm;
    }
}
